VTK: vtkVRMLExporter Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkVRMLExporter Class Reference

export a scene into VRML 2.0 format. More...

`#include <vtkVRMLExporter.h>`

Inheritance diagram for vtkVRMLExporter:
[legend]
Collaboration diagram for vtkVRMLExporter:
[legend]

## Public Types
typedef vtkExporter | Superclass
Public Types inherited from vtkExporter
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkVRMLExporter * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | SetFilePointer (FILE *)
| Set the file pointer to write to. More...
| vtkSetFilePathMacro (FileName)
| Specify the name of the VRML file to write. More...
| vtkGetFilePathMacro (FileName)
| Specify the name of the VRML file to write. More...
virtual void | SetSpeed (double)
| Specify the Speed of navigation. More...
virtual double | GetSpeed ()
| Specify the Speed of navigation. More...
Public Member Functions inherited from vtkExporter
vtkExporter * | NewInstance () const
virtual void | Write ()
| Write data to output. More...
void | Update ()
| Convenient alias for Write() method. More...
void | SetStartWrite (void(*f)(void *), void *arg)
| Specify a function to be called before data is written. More...
void | SetEndWrite (void(*f)(void *), void *arg)
| Specify a function to be called after data is written. More...
void | SetStartWriteArgDelete (void(*f)(void *))
| Set the arg delete method. More...
void | SetEndWriteArgDelete (void(*f)(void *))
| Set the arg delete method. More...
vtkMTimeType | GetMTime () override
| Returns the MTime also considering the RenderWindow. More...
virtual void | SetRenderWindow (vtkRenderWindow *)
| Set/Get the rendering window that contains the scene to be written. More...
virtual vtkRenderWindow * | GetRenderWindow ()
| Set/Get the rendering window that contains the scene to be written. More...
virtual void | SetActiveRenderer (vtkRenderer *)
| Set/Get the renderer that contains actors to be written. More...
virtual vtkRenderer * | GetActiveRenderer ()
| Set/Get the renderer that contains actors to be written. More...
void | SetInput (vtkRenderWindow *renWin)
| These methods are provided for backward compatibility. More...
vtkRenderWindow * | GetInput ()
| These methods are provided for backward compatibility. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkVRMLExporter * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkVRMLExporter * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkExporter
static vtkTypeBool | IsTypeOf (const char *type)
static vtkExporter * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkVRMLExporter ()
| ~vtkVRMLExporter () override
void | WriteData () override
void | WriteALight (vtkLight *aLight, FILE *fp)
void | WriteAnActor (vtkActor *anActor, FILE *fp)
void | WritePointData (vtkPoints *points, vtkDataArray *normals, vtkDataArray *tcoords, vtkUnsignedCharArray *colors, FILE *fp)
void | WriteShapeBegin (vtkActor *actor, FILE *fileP, vtkPolyData *polyData, vtkPointData *pntData, vtkUnsignedCharArray *color)
void | WriteShapeEnd (FILE *fileP)
Protected Member Functions inherited from vtkExporter
| vtkExporter ()
| ~vtkExporter () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
char * | FileName
FILE * | FilePointer
double | Speed
Protected Attributes inherited from vtkExporter
vtkRenderWindow * | RenderWindow
vtkRenderer * | ActiveRenderer
void(* | StartWrite )(void *)
void(* | StartWriteArgDelete )(void *)
void * | StartWriteArg
void(* | EndWrite )(void *)
void(* | EndWriteArgDelete )(void *)
void * | EndWriteArg
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

export a scene into VRML 2.0 format.

vtkVRMLExporter is a concrete subclass of vtkExporter that writes VRML 2.0 files. This is based on the VRML 2.0 draft #3 but it should be pretty stable since we aren't using any of the newer features.

See also
  vtkExporter

Online Examples:

Tests:
  vtkVRMLExporter (Tests)

Definition at line 42 of file vtkVRMLExporter.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkExporter vtkVRMLExporter::Superclass

Definition at line 46 of file vtkVRMLExporter.h.

## Constructor & Destructor Documentation

## ◆ vtkVRMLExporter()

vtkVRMLExporter::vtkVRMLExporter | ( |  | ) |
| protected

## ◆ ~vtkVRMLExporter()

vtkVRMLExporter::~vtkVRMLExporter | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkVRMLExporter* vtkVRMLExporter::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkVRMLExporter::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkVRMLExporter::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkExporter.

## ◆ SafeDownCast()

static vtkVRMLExporter* vtkVRMLExporter::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkVRMLExporter::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkExporter.

## ◆ NewInstance()

vtkVRMLExporter* vtkVRMLExporter::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkVRMLExporter::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkExporter.

## ◆ vtkSetFilePathMacro()

vtkVRMLExporter::vtkSetFilePathMacro | ( | FileName |  | ) |

Specify the name of the VRML file to write.

## ◆ vtkGetFilePathMacro()

vtkVRMLExporter::vtkGetFilePathMacro | ( | FileName |  | ) |

Specify the name of the VRML file to write.

## ◆ SetSpeed()

virtual void vtkVRMLExporter::SetSpeed | ( | double |  | ) |
| virtual

Specify the Speed of navigation.

Default is 4.

## ◆ GetSpeed()

virtual double vtkVRMLExporter::GetSpeed | ( |  | ) |
| virtual

Specify the Speed of navigation.

Default is 4.

## ◆ SetFilePointer()

void vtkVRMLExporter::SetFilePointer | ( | FILE * |  | ) |

Set the file pointer to write to.

This will override a FileName if specified.

## ◆ WriteData()

void vtkVRMLExporter::WriteData | ( |  | ) |
| overrideprotectedvirtual

Implements vtkExporter.

## ◆ WriteALight()

void vtkVRMLExporter::WriteALight | ( | vtkLight * | aLight,
|  | FILE * | fp
| ) |  |
| protected

## ◆ WriteAnActor()

void vtkVRMLExporter::WriteAnActor | ( | vtkActor * | anActor,
|  | FILE * | fp
| ) |  |
| protected

## ◆ WritePointData()

void vtkVRMLExporter::WritePointData | ( | vtkPoints * | points,
|  | vtkDataArray * | normals,
|  | vtkDataArray * | tcoords,
|  | vtkUnsignedCharArray * | colors,
|  | FILE * | fp
| ) |  |
| protected

## ◆ WriteShapeBegin()

void vtkVRMLExporter::WriteShapeBegin | ( | vtkActor * | actor,
|  | FILE * | fileP,
|  | vtkPolyData * | polyData,
|  | vtkPointData * | pntData,
|  | vtkUnsignedCharArray * | color
| ) |  |
| protected

## ◆ WriteShapeEnd()

void vtkVRMLExporter::WriteShapeEnd | ( | FILE * | fileP | ) |
| protected

## Member Data Documentation

## ◆ FileName

char* vtkVRMLExporter::FileName
| protected

Definition at line 83 of file vtkVRMLExporter.h.

## ◆ FilePointer

FILE* vtkVRMLExporter::FilePointer
| protected

Definition at line 84 of file vtkVRMLExporter.h.

## ◆ Speed

double vtkVRMLExporter::Speed
| protected

Definition at line 85 of file vtkVRMLExporter.h.

The documentation for this class was generated from the following file:

- IO/Export/vtkVRMLExporter.h